/*
NOTES: This version allows the maximum amount of parallelism. If a
       philosopher wants to eat and both of his neighbors are not
       eating, then the hungry philosopher gets to eat.

       This version allows starvation. Either pair of philosophers can
       starve the other pair by taking turns where each philosopher
       starts to eat just before its opposite stops eating.

       Also, this version uses busy waiting.
*/
// Globals:
Mutex mutexC = signaled; // for critical sections
int shared = 0;    // 0 means no one eating,
                   // pos means odds are eating
                   // neg means evens are eating

        oddPhilosopher(i)  // Philosophers p1 and p3
        {  while(1)
           {
              bool myTurn = false;
              repeat
              {
                  wait(mutexC);
                   if (shared >= 0)
                   {
                      shared++;
                      myTurn = true;
                   }
                  release(mutexC);
              }until(myTurn);
              // got the forks
              EAT();
              // now let go of the forks
              wait(mutexC);
               shared--;
              release(mutexC);
              THINK();
           }
        }                         evenPhilosopher(i) //Philosophers p2 and p4
            ____________________  {  while(1)
           |        ____        |    {
           |  \    | p1 |    /  |       bool myTurn = false;
           |    \  |____|  /    |       repeat
           | ____          ____ |       {
           || p4 |        | p2 ||          wait(mutexC);
           ||____|        |____||           if (shared <= 0)
           |                    |           {
           |    /   ____   \    |              shared--;
           |  /    | p3 |    \  |              myTurn = true;
           |       |____|       |           }
           |____________________|          release(mutexC);
                                        }until(myTurn);
                                        // got the forks
                                        EAT();
                                        // now let go of the forks
                                        wait(mutexC);
                                         shared++;
                                        release(mutexC);
                                        THINK();
                                     }
                                  }
