/*
   This version solves the starvation issue with the previous version.

   Unfortunately, this version no longer allows the maximum amount of
   parallelism.

   In fact, it is impossible to have a solution that both guarantees no
   starvation and allows the maximum amount of parallelism.
*/
Mutex mutexC = signaled; // for critical sections
int shared = 0;    // 0 means no one eating,
                   // pos means odds are eating
                   // neg means evens are eating
bool switchToEvens = false;  // these two variables are used to prevent starvation
bool switchToOdds  = false;

        oddPhilosopher(i)  // Philosophers p1 and p3
        {   while(1)
           {
              bool myTurn = false;
              repeat
              {
                  wait(mutexC);
                   if (shared >= 0)
                   {
                      if (!switchToEvens)
                      {
                         shared++;
                         myTurn = true;
                         switchToOdds = false;
                      }
                   }
                   else
                   {  switchToOdds = true; }
                  release(mutexC);
              }until(myTurn);
              // got the forks
              EAT();
              // now let go of the forks;
              wait(mutexC);
               shared--;
              release(mutexC);
              THINK();
           }
        }                         evenPhilosopher(i) //Philosophers p2 and p4
            ____________________  {  while(1)
           |        ____        |    {
           |  \    | p1 |    /  |       bool myTurn = false;
           |    \  |____|  /    |       repeat
           | ____          ____ |       {
           || p4 |        | p2 ||          wait(mutexC);
           ||____|        |____||           if (shared <= 0)
           |                    |           {
           |    /   ____   \    |              if (!switchToOdds)
           |  /    | p3 |    \  |              {
           |       |____|       |                 shared--;
           |____________________|                 myTurn = true;
                                                 switchToEvens = false;
                                               }
                                            }
                                            else
                                            { switchToEvens = true; }
                                           release(mutexC);
                                        }until(myTurn);
                                        // got the forks
                                        EAT();
                                        // now let go of the forks;
                                        wait(mutexC);
                                         shared++;
                                        release(mutexC);
                                        THINK();
                                     }
                                  }