/*
   A Solution to the Readers/Writers Problem Using Semaphores
   from "Operating Systems: Internals and Design principles", 5th Ed.,
   by Williams Stallings, page 244.

   Writers Have Priority
*/
int readCount = 0;
int writeCount = 0;
semaphore x = 1,
          y = 1,
          z = 1,
          writeSem = 1,
          readSem  = 1;


void reader()
{
   while (true)
   {
      semWait(z);         // make the readers queue up here (on z)
        semWait(readSem); // rather than here, on readSem
          semWait(x);
            readcount++;
            if (readcount == 1)
               semWait(writeSem);
          semSignal(x);
        semSignal(readSem);
      semSignal(z);
        read_data_base();        // access the data base
      semWait(x);
        readcount--;
        if (readcount == 0)
           semSignal(writeSem);
      semSignal(x);
      use_data_read();          // noncritical region
   }
}


void writer()
{
   while (true)
   {
      think_up_data();          // noncritical region
      semWait(y);
        writecount++;
        if (writecount == 1)
           semWait(readSem);
      semSignal(y);
      semWait(writeSem);
        write_data_base();      // update the data base
      semSignal(writeSem);
      semWait(y);
        writecount--;
        if (writecount == 0)
           semSignal(readSem);
      semSignal(y);
   }
}

