/*
   This program uses something like a mutex to avoid the race condition.

   This program implements the mutex like object by using the Pentium's
   BTS machine instruction. The mutex is implemented directly in this program.

   NOTE: This program does NOT work correctly on multicore and multi-processor
         systems since the BTS instruction does not implement the processors
         bus locking protocol.

         This program does work correctly on single core systems,
         and also on multicore systems if you set the affinity for
         this process (and all of its threads) to a single core.
*/
#include <stdio.h>
#include <windows.h>

// global variables
int runFlag = TRUE;
unsigned int count = 0, count1 = 0, count2 = 0;

int* mutex;

int main( int argc, char *argv[])
{
   DWORD WINAPI thread1(LPVOID);  //thread function prototypes
   DWORD WINAPI thread2(LPVOID);

   int threadParam1 = 0;  // thread function parameter
   int threadParam2 = 0;

   //Sleep(20000);  // If needed, during this time, use the "Task Manager"
                    // program to set the affinity of this process
                    // to a single core.

   // create a mutex (like) object
   mutex = (int*)malloc(sizeof(int));
   *mutex = 0;   // signaled

   // create threads
   printf("race4m: Starting threads\n");
   CreateThread(NULL, 0, thread1, &threadParam1, 0, NULL);
   CreateThread(NULL, 0, thread2, &threadParam2, 0, NULL);

   // let the threads run for a while
   Sleep(2000);
   // now stop the threads
   runFlag = FALSE;
   Sleep(20);

   printf("\nThreads stopped.\n");
   printf("count = %d, count1 = %d, count2 = %d\n", count, count1, count2);

   return 0;
}//main


DWORD WINAPI thread1(LPVOID threadParam)
{
   unsigned int new_count, old_count;
   while(runFlag)
   {
      //BeginCriticalSection()
      //{
        __asm mov eax, mutex
bitSet: __asm bts [eax], 0
        __asm jc  bitSet
      //}
      // enter critical section
      old_count = count++;
      new_count = count;
      //EndCriticalSection()
      //{
      *mutex = 0;
      //}

      if (new_count - old_count != 1)
         printf("Bingo1: new_count - old_count = %d\n", new_count-old_count);
      count1++;
   }
   return 0;
}//thread1


DWORD WINAPI thread2(LPVOID threadParam)
{
   unsigned int new_count, old_count;
   while(runFlag)
   {
      //BeginCriticalSection()
      //{
        __asm mov eax, mutex
bitSet: __asm bts [eax], 0
        __asm jc  bitSet
      //}
      // enter critical section
      old_count = count++;
      new_count = count;
      //EndCriticalSection()
      //{
      *mutex = 0;
      //}

      if (new_count - old_count != 1)
         printf("Bingo2: new_count - old_count = %d\n", new_count-old_count);
      count2++;
   }
   return 0;
}//thread2
