/*
     This program demonstrates a very simple example
     of a critical section in a thread. This program
     starts up two threads, both of which print out
     a single letter in rows of 10. In the output we
     expect to see a block of a's, in rows of 10, followed
     by a block of b's, in rows of 10, etc. But instead
     we see that where one block begins and another ends
     a row can become mixed up with a's and b's. That is
     because a thread's time quantum can run out in the
     middle of printing a row. When that happens, one
     thread can start one of its rows in the middle of
     the other thread's row.

     This program shows that we need a way for a thread to
     be able to prevent other threads from interupting it
     at certain "critical times".
*/
#include <stdio.h>
#include <windows.h>

// global flag
static int runFlag = TRUE;

int main( int argc, char *argv[])
{
   //thread function prototypes
   DWORD WINAPI thread1(LPVOID);
   DWORD WINAPI thread2(LPVOID);

   // thread function parameters
   int threadParam1 = 0;
   int threadParam2 = 0;

   // create threads
   printf("Starting threads\n");
   CreateThread(NULL, 0, thread1, &threadParam1, 0, NULL);
   CreateThread(NULL, 0, thread2, &threadParam2, 0, NULL);

   Sleep(2000);     // let the threads run for a while
   runFlag = FALSE; // now stop the threads
   Sleep(200);      // give them time to stop
   printf("\nThreads stopped.\n");

   return 0;
}//main


DWORD WINAPI thread1(LPVOID threadParam)
{
   while(runFlag)
   {
      int i;
      // print a row of 10 letters
      for(i = 0; i < 10; i++)
      {
         printf("a");
      }
      printf("\n");
   }
   return 0;
}//thread1


DWORD WINAPI thread2(LPVOID threadParam)
{
   while(runFlag)
   {
      int i;
      // print a row of 10 letters
      for(i = 0; i < 10; i++)
      {
         printf("b");
      }
      printf("\n");
   }
   return 0;
}//thread2
