/*
   This program uses a mutex to solve the "critical section"
   problem from criticalSection1.c
*/
#include <stdio.h>
#include <windows.h>

// global flag
static int runFlag = TRUE;

HANDLE mutex; // Mutex handle

int main( int argc, char *argv[])
{
   //thread function prototypes
   DWORD WINAPI thread1(LPVOID);
   DWORD WINAPI thread2(LPVOID);

   // thread function parameters
   int threadParam1 = 0;
   int threadParam2 = 0;

   // create a Mutex object (in signaled state)
   mutex = CreateMutex(NULL, FALSE, NULL);

   // create threads
   printf("Starting threads\n");
   CreateThread(NULL, 0, thread1, &threadParam1, 0, NULL);
   CreateThread(NULL, 0, thread2, &threadParam2, 0, NULL);

   Sleep(2000);     // let the threads run for a while
   runFlag = FALSE; // now stop the threads
   Sleep(200);      // give them time to stop
   printf("\nThreads stopped.\n");

   return 0;
}//main


DWORD WINAPI thread1(LPVOID threadParam)
{
   while(runFlag)
   {
      int i;
      WaitForSingleObject(mutex, INFINITE);
      // print rows of 10 letters
      for(i = 0; i < 10; i++)
      {
         printf("a");
      }
      printf("\n");
      ReleaseMutex(mutex);
   }
   return 0;
}//thread1


DWORD WINAPI thread2(LPVOID threadParam)
{
   while(runFlag)
   {
      int i;
      WaitForSingleObject(mutex, INFINITE);
      // print rows of 10 letters
      for(i = 0; i < 10; i++)
      {
         printf("b");
      }
      printf("\n");
      ReleaseMutex(mutex);
   }
   return 0;
}//thread2
