/*
     This program, like the last one, has two threads each of which
     prints out rows of letters. But in this program, each thread
     prints one row by using a single call to the C++ library function
     cout (the last program used the C Library function printf). In the
     output we see that there are once again mixed up rows with some
     letter a's and some letter b's. And it does not matter which compiler
     we use, cl or gcc. When a thread requests that cout print out a single
     row, that output request can get interrupted by the other thread's output.
*/
#include <iostream>
#include <windows.h>

using namespace std;

// global flag
static int runFlag = TRUE;

int main( int argc, char *argv[])
{
   //thread function prototypes
   DWORD WINAPI thread1(LPVOID);
   DWORD WINAPI thread2(LPVOID);

   int threadParam1 = 0;  // thread function parameter
   int threadParam2 = 0;

   // create threads
   cout << "Starting threads" << endl;
   CreateThread(NULL, 0, thread1, &threadParam1, 0, NULL);
   CreateThread(NULL, 0, thread2, &threadParam2, 0, NULL);

   Sleep(2000);     // let the threads run for a while
   runFlag = FALSE; // now stop the threads
   Sleep(200);      // give them time to stop
   cout << "\nThreads stopped" << endl;

   return 0;
}//main


DWORD WINAPI thread1(LPVOID threadParam)
{
   while(runFlag)
   {
      // print a row of 50 letters
      cout << "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" << endl;
   }
   return 0;
}//thread1


DWORD WINAPI thread2(LPVOID threadParam)
{
   while(runFlag)
   {
      // print a row of 50 letters
      cout << "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb" << endl;
   }
   return 0;
}//thread2
