/*
   This program uses a binary semaphore to solve the "critical section"
   problem from criticalSection1.c
*/
#include <stdio.h>    // printf()
#include <unistd.h>   // sleep()
#include <pthread.h>
#include <semaphore.h>

// global flag
static int runFlag = 1;

sem_t semaphore;

int main( int argc, char *argv[])
{
   //thread function prototypes
   void *thread1(void *vargp);
   void *thread2(void *vargp);

   // thread function parameters
   int threadParam1 = 0;
   int threadParam2 = 0;

   pthread_t tid1;
   pthread_t tid2;

   // initialize the (binary) semaphore (in signaled state)
   sem_init(&semaphore, 0, 1);

   // create threads
   printf("Starting threads\n");
   pthread_create(&tid1, NULL, thread1, &threadParam1);
   pthread_create(&tid2, NULL, thread2, &threadParam2);

   sleep(2);     // let the threads run for a while
   runFlag = 0;  // now stop the threads
   sleep(1);     // give them time to stop
   printf("\nThreads stopped.\n");

   return 0;
}//main


void *thread1(void *vargp)
{
   while(runFlag)
   {
      int i;
      sem_wait(&semaphore);
      // print rows of 10 letters
      for(i = 0; i < 10; i++)
      {
         printf("a");
      }
      printf("\n");
      sem_post(&semaphore);
   }
   return NULL;
}//thread1


void *thread2(void *vargp)
{
   while(runFlag)
   {
      int i;
      sem_wait(&semaphore);
      // print rows of 10 letters
      for(i = 0; i < 10; i++)
      {
         printf("b");
      }
      printf("\n");
      sem_post(&semaphore);
   }
   return NULL;
}//thread2
