/*
     This program, like the last two, has two threads each of
     which prints out rows of letters. But in this program, each
     thread prints one row by using a single call to the C library
     function printf().

     When compiled and linked with Cygwin, the output of this program is
     synchronized in the "right" way, that is, we see blocks of a's in
     rows of 50 and then blocks of b's in rows of 50. There are no mixed
     up rows with some letter a's and some letter b's. Once a thread requests
     that printf() print out a single row, that output request does not get
     interrupted by the other thread's output.
*/
#include <stdio.h>    // printf()
#include <unistd.h>   // sleep()
#include <pthread.h>

// global flag
static int runFlag = 1;

int main( int argc, char *argv[])
{
   // thread function prototypes
   void *thread1(void *vargp);
   void *thread2(void *vargp);

   // thread function parameters
   int threadParam1 = 0;
   int threadParam2 = 0;

   pthread_t tid1;
   pthread_t tid2;

   // create threads
   printf("Starting threads\n");
   pthread_create(&tid1, NULL, thread1, &threadParam1);
   pthread_create(&tid2, NULL, thread2, &threadParam2);

   sleep(2);     // let the threads run for a while
   runFlag = 0;  // now stop the threads
   sleep(1);     // give them time to stop
   printf("\nThreads stopped.\n");

   return 0;
}//main


void *thread1(void *vargp)
{
   while(runFlag)
   {
      // print a row of 50 letters
      printf("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa\n");
   }
   return NULL;
}//thread1


void *thread2(void *vargp)
{
   while(runFlag)
   {
      // print a row of 50 letters
      printf("bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb\n");
   }
   return NULL;
}//thread2
