/*
     This program, like the last one, has two threads each of which
     prints out rows of letters. But in this program, each thread
     prints one row by using a single call to the C++ library function
     cout (the last program used the C Library function printf).

     In the output we see that there are once again mixed up rows with
     some letter a's and some letter b's.
*/
#include <iostream>   // cout, endl
#include <unistd.h>   // sleep()
#include <pthread.h>

using namespace std;

// global flag
static int runFlag = 1;

int main( int argc, char *argv[])
{
   //thread function prototypes
   void *thread1(void *vargp);  //thread function prototypes
   void *thread2(void *vargp);

   // thread function parameters
   int threadParam1 = 0;
   int threadParam2 = 0;

   pthread_t tid1;
   pthread_t tid2;

   // create threads
   cout << "Starting threads" << endl;
   pthread_create(&tid1, NULL, thread1, &threadParam1);
   pthread_create(&tid2, NULL, thread2, &threadParam2);

   sleep(2);     // let the threads run for a while
   runFlag = 0;  // now stop the threads
   sleep(1);     // give them time to stop
   cout << "\nThreads stopped" << endl;

   return 0;
}//main


void *thread1(void *vargp)
{
   while(runFlag)
   {
      // print a row of 50 letters
      cout << "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa" << endl;
   }
   return NULL;
}//thread1


void *thread2(void *vargp)
{
   while(runFlag)
   {
      // print a row of 50 letters
      cout << "bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb" << endl;
   }
   return NULL;
}//thread2
