/*
   This program is a mixture of Posix and Win32 API's. It will
   compile under Cygwin (and maybe Wine?).

   This version uses a thread to display the message box. Each display
   thread blocks until the user clicks the "OK" button in its message box.
   But the main thread of the application does not block, so the program's
   user can keep on entering numbers, even while a message box is displayed.
*/
#include <windows.h>
#include <stdio.h>   // printf(), sprintf(), scanf()
#include <pthread.h>

// thread function prototype
void *displayMessageBox(void *vargp);

int main()
{
   pthread_t tid;
   int number;
   while(1)
   {
      printf("Please enter a number: ");
      scanf("%d", &number);
      // create a thread to display the message box
      pthread_create(&tid, NULL, displayMessageBox, &number);
   }
   return 0;  // the main function never returns
}//main


void *displayMessageBox(void *threadParam)
{
   int number = *(int*)threadParam;
   char titleText[] = "Here is what you entered";
   char messageText[20];
   sprintf(messageText, "Your number is %d.", number);
   MessageBox(NULL, messageText, titleText, MB_OK | MB_ICONINFORMATION | MB_TOPMOST);
   return NULL;
}//displayMessageBox
