/*
    This program calls the "thread functions" as regular functions,
    that is, they are called sequentially.

    This program passes parameters (by reference) to the "thread functions".
    The pointers to the parameters are on the (main thread's) stack.
*/
#include <stdio.h>    // fprintf(), stderr
#include <unistd.h>   // sleep()
#include <pthread.h>

// function prototypes
void *thread1(void *vargp);
void *thread2(void *vargp);

int main()
{
   int arg1 = 101;
   int arg2 = 202;

   fprintf(stderr, "Address of arg1 = %d\n", (int)&arg1);
   fprintf(stderr, "Address of arg1 = %d\n\n", (int)&arg1);

   thread1(&arg1);
   thread2(&arg2);

   fprintf(stderr, "\nAll done.\n");

   return 0;
}

void *thread1(void *vargp)
{
   int arg = *((int*)vargp); // vargp means "variable (length) argument pointer"

   fprintf(stderr, "hello ");
   sleep(1);
   fprintf(stderr, "from thread 1");
   sleep(1);
   fprintf(stderr, " with argument %d at location %d!\n", arg, (int)&vargp);
   return NULL;
}

void *thread2(void *vargp)
{
   int arg = *((int*)vargp);

   fprintf(stderr, "HELLO FROM ");
   sleep(1);
   fprintf(stderr, "THREAD 2");
   sleep(1);
   fprintf(stderr, " WITH ARGUMENT %d AT LOCATION %d?\n", arg, (int)&vargp);
   return NULL;
}
